module SalesReporter
  module Reports
    class SalesByCountry
      def self.render(sales)
        sales_by_country = {}

        sales.each do |s|
          c = s.country
          if sales_by_country[c]
            sales_by_country[c][:count] += s.quantity
            sales_by_country[c][:total] += s.amount
          else
            sales_by_country[c] = {:count => s.quantity, :total => s.amount}
          end
        end

        sorted = sales_by_country.sort { |a,b| b[1][:count] <=> a[1][:count] }

        puts "Country: Streams:  Revenue:"
        puts "------------------------------------------"

        total_rev = 0
        total_streams = 0

        sorted.each do |key, row|
          puts "#{key}:       #{row[:count].to_s.rjust(7)} #{row[:total].round(5).to_s.rjust(10)} EUR"
          total_rev += row[:total]
          total_streams += row[:count]
        end

        puts "------------------------------------------"
        puts "Total:      #{total_streams.to_s.rjust(7)} #{total_rev.round(5).to_s.rjust(10)} EUR"
      end
    end
  end
end
